org.apache.jasper

## Class EmbeddedServletOptions

- java.lang.Object
- - org.apache.jasper.EmbeddedServletOptions

All Implemented Interfaces:
  Options

    public final class EmbeddedServletOptions
    extends Object
    implements Options

A class to hold all init parameters specific to the JSP engine.

Author:
  Anil K. Vijendran, Hans Bergsten, Pierre Delisle

### Field Summary

Fields
`boolean` `fork` Should Ant fork its java compiles of JSP pages.

### Constructor Summary

Constructors
Constructor and Description
`EmbeddedServletOptions(ServletConfig config, ServletContext context)` Create an EmbeddedServletOptions object using data available from ServletConfig and ServletContext.

### Method Summary

Methods
`boolean` `genStringAsCharArray()` Are Text strings to be generated as char arrays?
`Map<String,TagLibraryInfo>` `getCache()` The web-application wide cache for the TagLibraryInfo tag library descriptors, used if `Options.isCaching()` returns `true`.
`int` `getCheckInterval()` Background JSP compile thread check interval
`boolean` `getClassDebugInfo()` Should class files be compiled with debug information?
`String` `getClassPath()` What classpath should I use while compiling the servlets generated from JSP files?
`String` `getCompiler()` Compiler to use.
`String` `getCompilerClassName()` Java compiler class to use.
`String` `getCompilerSourceVM()` The compiler source VM, e.g. 1.3, 1.4, 1.5 or 1.6.
`String` `getCompilerTargetVM()` The compiler target VM, e.g. 1.1, 1.2, 1.3, 1.4, 1.5 or 1.6.
`boolean` `getDevelopment()` Is Jasper being used in development mode?
`boolean` `getDisplaySourceFragment()` Should we include a source fragment in exception messages, which could be displayed to the developer ?
`boolean` `getErrorOnUseBeanInvalidClassAttribute()` Returns true if Jasper issues a compilation error instead of a runtime Instantiation error if the class attribute specified in useBean action is invalid.
`boolean` `getFork()` The boolean flag to tell Ant whether to fork JSP page compilations.
`String` `getIeClassId()` Class ID for use in the plugin tag when the browser is IE.
`String` `getJavaEncoding()` Java platform encoding to generate the JSP page servlet.
`JspConfig` `getJspConfig()` Obtain JSP configuration information specified in web.xml.
`int` `getJspIdleTimeout()` Should any jsps be unloaded when being idle for this time in seconds?
`boolean` `getKeepGenerated()` Are we keeping generated code around?
`boolean` `getMappedFile()` Are we supporting HTML mapped servlets?
`int` `getMaxLoadedJsps()` Should jsps be unloaded if to many are loaded?
`int` `getModificationTestInterval()` Modification test interval.
`String` `getProperty(String name)`
`boolean` `getRecompileOnFail()` Re-compile on failure.
`File` `getScratchDir()` What is my scratch dir?
`TagPluginManager` `getTagPluginManager()` Obtain a Tag Plugin Manager
`TldLocationsCache` `getTldLocationsCache()` The cache for the location of the TLD's for the various tag libraries 'exposed' by the web application.
`boolean` `getTrimSpaces()` Should white spaces between directives or actions be trimmed?
`boolean` `isCaching()` Is caching enabled (used for precompilation).
`boolean` `isPoolingEnabled()` Returns true if tag handler pooling is enabled, false otherwise.
`boolean` `isSmapDumped()` Should SMAP info for JSR45 debugging be dumped to a file?
`boolean` `isSmapSuppressed()` Is the generation of SMAP info for JSR45 debugging suppressed?
`boolean` `isXpoweredBy()` Is generation of X-Powered-By response header enabled/disabled?
`void` `setErrorOnUseBeanInvalidClassAttribute(boolean b)`
`void` `setProperty(String name, String value)`
`void` `setTldLocationsCache(TldLocationsCache tldC)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### fork

    public boolean fork

Should Ant fork its java compiles of JSP pages.

### Constructor Detail

#### EmbeddedServletOptions

    public EmbeddedServletOptions(ServletConfig config,
                          ServletContext context)

Create an EmbeddedServletOptions object using data available from ServletConfig and ServletContext.

### Method Detail

#### getProperty

    public String getProperty(String name)

#### setProperty

    public void setProperty(String name,
                   String value)

#### getKeepGenerated

    public boolean getKeepGenerated()

Are we keeping generated code around?

Specified by:
  `getKeepGenerated` in interface `Options`

#### getTrimSpaces

    public boolean getTrimSpaces()

Should white spaces between directives or actions be trimmed?

Specified by:
  `getTrimSpaces` in interface `Options`

#### isPoolingEnabled

    public boolean isPoolingEnabled()

Description copied from interface: `Options`
Returns true if tag handler pooling is enabled, false otherwise.

Specified by:
  `isPoolingEnabled` in interface `Options`

#### getMappedFile

    public boolean getMappedFile()

Are we supporting HTML mapped servlets?

Specified by:
  `getMappedFile` in interface `Options`

#### getClassDebugInfo

    public boolean getClassDebugInfo()

Should class files be compiled with debug information?

Specified by:
  `getClassDebugInfo` in interface `Options`

#### getCheckInterval

    public int getCheckInterval()

Background JSP compile thread check interval

Specified by:
  `getCheckInterval` in interface `Options`

#### getModificationTestInterval

    public int getModificationTestInterval()

Modification test interval.

Specified by:
  `getModificationTestInterval` in interface `Options`

#### getRecompileOnFail

    public boolean getRecompileOnFail()

Re-compile on failure.

Specified by:
  `getRecompileOnFail` in interface `Options`

#### getDevelopment

    public boolean getDevelopment()

Is Jasper being used in development mode?

Specified by:
  `getDevelopment` in interface `Options`

#### isSmapSuppressed

    public boolean isSmapSuppressed()

Is the generation of SMAP info for JSR45 debugging suppressed?

Specified by:
  `isSmapSuppressed` in interface `Options`

#### isSmapDumped

    public boolean isSmapDumped()

Should SMAP info for JSR45 debugging be dumped to a file?

Specified by:
  `isSmapDumped` in interface `Options`

#### genStringAsCharArray

    public boolean genStringAsCharArray()

Are Text strings to be generated as char arrays?

Specified by:
  `genStringAsCharArray` in interface `Options`
Returns:
  `true` if text strings are to be generated as char arrays, `false` otherwise

#### getIeClassId

    public String getIeClassId()

Class ID for use in the plugin tag when the browser is IE.

Specified by:
  `getIeClassId` in interface `Options`
Returns:
  Class-id value

#### getScratchDir

    public File getScratchDir()

What is my scratch dir?

Specified by:
  `getScratchDir` in interface `Options`

#### getClassPath

    public String getClassPath()

What classpath should I use while compiling the servlets generated from JSP files?

Specified by:
  `getClassPath` in interface `Options`

#### isXpoweredBy

    public boolean isXpoweredBy()

Is generation of X-Powered-By response header enabled/disabled?

Specified by:
  `isXpoweredBy` in interface `Options`

#### getCompiler

    public String getCompiler()

Compiler to use.

Specified by:
  `getCompiler` in interface `Options`

#### getCompilerTargetVM

    public String getCompilerTargetVM()

Description copied from interface: `Options`
The compiler target VM, e.g. 1.1, 1.2, 1.3, 1.4, 1.5 or 1.6.

Specified by:
  `getCompilerTargetVM` in interface `Options`
See Also:
  `Options.getCompilerTargetVM()`

#### getCompilerSourceVM

    public String getCompilerSourceVM()

Description copied from interface: `Options`
The compiler source VM, e.g. 1.3, 1.4, 1.5 or 1.6.

Specified by:
  `getCompilerSourceVM` in interface `Options`
See Also:
  `Options.getCompilerSourceVM()`

#### getCompilerClassName

    public String getCompilerClassName()

Java compiler class to use.

Specified by:
  `getCompilerClassName` in interface `Options`

#### getErrorOnUseBeanInvalidClassAttribute

    public boolean getErrorOnUseBeanInvalidClassAttribute()

Description copied from interface: `Options`
Returns true if Jasper issues a compilation error instead of a runtime Instantiation error if the class attribute specified in useBean action is invalid.

Specified by:
  `getErrorOnUseBeanInvalidClassAttribute` in interface `Options`

#### setErrorOnUseBeanInvalidClassAttribute

    public void setErrorOnUseBeanInvalidClassAttribute(boolean b)

#### getTldLocationsCache

    public TldLocationsCache getTldLocationsCache()

Description copied from interface: `Options`
The cache for the location of the TLD's for the various tag libraries 'exposed' by the web application. A tag library is 'exposed' either explicitly in web.xml or implicitly via the uri tag in the TLD of a taglib deployed in a jar file (WEB-INF/lib).

Specified by:
  `getTldLocationsCache` in interface `Options`
Returns:
  the instance of the TldLocationsCache for the web-application.

#### setTldLocationsCache

    public void setTldLocationsCache(TldLocationsCache tldC)

#### getJavaEncoding

    public String getJavaEncoding()

Description copied from interface: `Options`
Java platform encoding to generate the JSP page servlet.

Specified by:
  `getJavaEncoding` in interface `Options`

#### getFork

    public boolean getFork()

Description copied from interface: `Options`
The boolean flag to tell Ant whether to fork JSP page compilations.

Is used only when Jasper uses an external java compiler (wrapped through a `javac` Apache Ant task).

Specified by:
  `getFork` in interface `Options`

#### getJspConfig

    public JspConfig getJspConfig()

Description copied from interface: `Options`
Obtain JSP configuration information specified in web.xml.

Specified by:
  `getJspConfig` in interface `Options`

#### getTagPluginManager

    public TagPluginManager getTagPluginManager()

Description copied from interface: `Options`
Obtain a Tag Plugin Manager

Specified by:
  `getTagPluginManager` in interface `Options`

#### isCaching

    public boolean isCaching()

Description copied from interface: `Options`
Is caching enabled (used for precompilation).

Specified by:
  `isCaching` in interface `Options`

#### getCache

    public Map<String,TagLibraryInfo> getCache()

Description copied from interface: `Options`
The web-application wide cache for the TagLibraryInfo tag library descriptors, used if `Options.isCaching()` returns `true`.

Using this cache avoids the cost of repeating the parsing of a tag library descriptor XML file (performed by TagLibraryInfoImpl.parseTLD).

Specified by:
  `getCache` in interface `Options`
Returns:
  the Map(String uri, TagLibraryInfo tld) instance.

#### getDisplaySourceFragment

    public boolean getDisplaySourceFragment()

Should we include a source fragment in exception messages, which could be displayed to the developer ?

Specified by:
  `getDisplaySourceFragment` in interface `Options`

#### getMaxLoadedJsps

    public int getMaxLoadedJsps()

Should jsps be unloaded if to many are loaded? If set to a value greater than 0 eviction of jsps is started. Default: -1

Specified by:
  `getMaxLoadedJsps` in interface `Options`

#### getJspIdleTimeout

    public int getJspIdleTimeout()

Should any jsps be unloaded when being idle for this time in seconds? If set to a value greater than 0 eviction of jsps is started. Default: -1

Specified by:
  `getJspIdleTimeout` in interface `Options`